{% extends 'base.html.twig' %}

{% block body %}
    <div class="container">
        <div class="section">
            <div class="row">
                <div class="col s12 center">
                    <h4>Participez en quelques secondes</h4>
                </div>
            </div>
            <!--   Form Section   -->
            <div class="card">
                <div class="card-content">
                    <div class="row">
                        <form action="{{ path('payment_charge') }}" method="post" id="payment-form">
                            <h5 class="center">Votre identité</h5>
                            <div class="input-field col s12 l6">
                                <input id="email" type="email" name="email" class="validate" required>
                                <label for="email">Votre Email</label>
                            </div>
                            <div class="input-field col s12 l6">
                                <input id="name" type="text" name="name" class="validate" required>
                                <label for="name">Votre nom</label>
                            </div>
                            <div class="input-field col s12 l6">
                                <input id="mount" type="number" name="amount" class="validate" value="{{ amount_participant|default(0) }}">
                                <label for="mount">Votre participation</label>
                            </div>
                            <div class="clearfix"></div>
                            <div id="card-element">
                                <!-- A Stripe Element will be inserted here. -->
                            </div>
                            <!-- Used to display Element errors. -->
                            <div id="card-errors" role="alert"></div>
                            <div class="input-field col s12 l6">
                                <a href="#!" class="btn btn-large waves-effect waves-light grey col s12">Annuler</a>
                            </div>
                            <div class="input-field col s12 l6">
                                <button class="btn btn-large waves-effect waves-light pink lighten-1 col s12" type="submit" name="action">
                                    Participer
                                    <i class="material-icons right">euro_symbol</i>
                                </button>
                            </div>
                            <input type="hidden" name="campaign_id" value="{{ campaign.id }}">
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    
{% endblock %}

{% block javascripts %}
    <script src="https://js.stripe.com/v3/"></script>
    
    <script>
        var stripe = Stripe('pk_test_6P3qDD0rK85o458gM4ILMh7V');
        var elements = stripe.elements();

        // Custom styling can be passed to options when creating an Element.
        var style = {
            base: {
                // Add your base input styles here. For example:
                fontSize: '16px',
                color: "#32325d",
            }
        };
  
        // Create an instance of the card Element.
        var card = elements.create('card', {style: style});
  
        // Add an instance of the card Element into the `card-element` <div>.
        card.mount('#card-element');

        card.addEventListener('change', function(event) {
            var displayError = document.getElementById('card-errors');
            if (event.error) {
                displayError.textContent = event.error.message;
            } else {
                displayError.textContent = '';
            }
        });
        
        // Create a token or display an error when the form is submitted.
        var form = document.getElementById('payment-form');
        form.addEventListener('submit', function(event) {
            event.preventDefault();

            stripe.createToken(card).then(function(result) {
                if (result.error) {
                    // Inform the customer that there was an error.
                    var errorElement = document.getElementById('card-errors');
                    errorElement.textContent = result.error.message;
                } else {
                    // Send the token to your server.
                    stripeTokenHandler(result.token);
                }
            });
        });
        
        function stripeTokenHandler(token) {
            // Insert the token ID into the form so it gets submitted to the server
            var form = document.getElementById('payment-form');
            var hiddenInput = document.createElement('input');
            hiddenInput.setAttribute('type', 'hidden');
            hiddenInput.setAttribute('name', 'stripeToken');
            hiddenInput.setAttribute('value', token.id);
            form.appendChild(hiddenInput);
          
            // Submit the form
            form.submit();
        }
    </script>
{% endblock %}